# -*- coding: utf-8 -*-
from setuphelpers import *
import json
import glob


def update_package():
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    api_url = "https://sourceforge.net/projects/sweethome3d/best_release.json"

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = wgets(api_url, proxies=proxies, as_json=True)
    for to_download in json_load["platform_releases"]["windows"]:
        latest_bin = json_load["platform_releases"]["windows"]["filename"].split("/")[-1]
        download_url = json_load["platform_releases"]["windows"]["url"].replace("http://", "https://")
        version = json_load["platform_releases"]["windows"]["filename"].split("/")[1].replace("v", "")
        break

    version = latest_bin.split("-")[1]
    print("Latest Version : " + version)

    for fn in glob.glob("*.exe"):
        if fn != latest_bin:
            remove_file(fn)

    if not isfile(latest_bin):
        print("Downloading %s from %s" % (latest_bin, latest_bin))
        wget(download_url, latest_bin, proxies=proxies, download_timeout=900)
    else:
        print("Already up to date, skipped")

    # Changing version of the package
    control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
    control.save_control_to_wapt()
    print("Changing package version to: %s in WAPT\\control" % control.version)

